org.apache.hc.core5.http.io.entity

## Class InputStreamEntity

- java.lang.Object
- - org.apache.hc.core5.http.io.entity.AbstractHttpEntity
  - - org.apache.hc.core5.http.io.entity.InputStreamEntity

- All Implemented Interfaces:
    Closeable, AutoCloseable, EntityDetails, HttpEntity

      public class InputStreamEntity
      extends AbstractHttpEntity

  A streamed, non-repeatable entity that obtains its content from an `InputStream`.
  Since:
    4.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `InputStreamEntity(InputStream content, ContentType contentType)` Constructs a new instance with the given attributes kept as immutable.
    `InputStreamEntity(InputStream content, long contentLength, ContentType contentType)` Constructs a new instance with the given attributes kept as immutable.
    `InputStreamEntity(InputStream content, long contentLength, ContentType contentType, String contentEncoding)` Constructs a new instance with the given attributes kept as immutable.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()`
    `InputStream` | `getContent()` Gets a content stream of the entity.
    `long` | `getContentLength()` Gets length of this entity, if known.
    `boolean` | `isRepeatable()` Tests if the entity is capable of producing its data more than once.
    `boolean` | `isStreaming()` Tests whether this entity depends on an underlying stream.
    `void` | `writeTo(OutputStream outStream)` Writes bytes from the `InputStream` this entity was constructed with to an `OutputStream`.

    - ### Methods inherited from class org.apache.hc.core5.http.io.entity.AbstractHttpEntity

      `getContentEncoding, getContentType, getTrailerNames, getTrailers, isChunked, toString, writeTo`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### InputStreamEntity

          public InputStreamEntity(InputStream content,
                                   long contentLength,
                                   ContentType contentType,
                                   String contentEncoding)

      Constructs a new instance with the given attributes kept as immutable.

      The new instance:

      - is not chunked.
      Parameters:
        `content` - The message body contents as an InputStream.
        `contentLength` - The value for the `Content-Length` header for the size of the message body, in bytes.
        `contentType` - The content-type, may be null.
        `contentEncoding` - The content encoding string, may be null.

    - #### InputStreamEntity

          public InputStreamEntity(InputStream content,
                                   long contentLength,
                                   ContentType contentType)

      Constructs a new instance with the given attributes kept as immutable.

      The new instance:

      - is not chunked.
      - does not define a content encoding.
      Parameters:
        `content` - The message body contents as an InputStream.
        `contentLength` - The value for the `Content-Length` header for the size of the message body, in bytes.
        `contentType` - The content-type, may be null.

    - #### InputStreamEntity

          public InputStreamEntity(InputStream content,
                                   ContentType contentType)

      Constructs a new instance with the given attributes kept as immutable.

      The new instance:

      - is not chunked.
      - does not define a content length.
      - does not define a content encoding.
      Parameters:
        `content` - The message body contents as an InputStream.
        `contentType` - The content-type, may be null.

  - ### Method Detail

    - #### isRepeatable

          public final boolean isRepeatable()

      Tests if the entity is capable of producing its data more than once. A repeatable entity's getContent() and writeTo(OutputStream) methods can be called more than once whereas a non-repeatable entity's can not.

      This implementation always returns `false`.

      This implementation always returns `false`.

      Specified by:
        `isRepeatable` in interface `HttpEntity`
      Overrides:
        `isRepeatable` in class `AbstractHttpEntity`
      Returns:
        true if the entity is repeatable, false otherwise.

    - #### getContentLength

          public final long getContentLength()

      Gets length of this entity, if known.
      Returns:
        the content length or `-1` if unknown.

    - #### getContent

          public final InputStream getContent()
                                       throws IOException

      Description copied from interface: `HttpEntity`
      Gets a content stream of the entity. `Repeatable` entities are expected to create a new instance of `InputStream` for each invocation of this method and therefore can be consumed multiple times. Entities that are not `repeatable` are expected to return the same `InputStream` instance and therefore may not be consumed more than once.

      If this entity belongs to an incoming HTTP message, calling `InputStream.close()` on the returned `InputStream` will try to consume the complete entity content to keep the connection alive. In cases where this is undesired, e.g. when only a small part of the content is relevant and consuming the complete entity content would be too inefficient, only the HTTP message from which this entity was obtained should be closed (if supported).

      IMPORTANT: Please note all entity implementations must ensure that all allocated resources are properly deallocated after the `InputStream.close()` method is invoked.

      Returns:
        content stream of the entity.
      Throws:
        `IOException` - if the stream could not be created
      See Also:
        `HttpEntity.isRepeatable()`

    - #### writeTo

          public final void writeTo(OutputStream outStream)
                             throws IOException

      Writes bytes from the `InputStream` this entity was constructed with to an `OutputStream`. The content length determines how many bytes are written. If the length is unknown (`-1`), the stream will be completely consumed (to the end of the stream).
      Specified by:
        `writeTo` in interface `HttpEntity`
      Overrides:
        `writeTo` in class `AbstractHttpEntity`
      Parameters:
        `outStream` - Where to write the entity, never null.
      Throws:
        `IOException` - if the entity cannot generate its content stream; also thrown if the output stream is closed.

    - #### isStreaming

          public final boolean isStreaming()

      Tests whether this entity depends on an underlying stream. Streamed entities that read data directly from the socket should return `true`. Self-contained entities should return `false`. Wrapping entities should delegate this call to the wrapped entity.

      This implementation always returns `true`.

      Returns:
        `true` if the entity content is streamed, `false` otherwise

    - #### close

          public final void close()
                           throws IOException

      Throws:
        `IOException`

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.